# Haliasaineisto

# Haetaan varsinainen aineiston csv-tiedosto / choose the csv-file
setwd("/Users/aleksilehikoinen/Documents2/Halias/2000-/OpenAccess/v1.7/")
Halias <- read.csv("Haliasdata_v1.7.csv", fileEncoding="macintosh") # Haliasdata_v1.7.csv

str(Halias) # aineiston rakenne / structure of the data

# Haetaan lajeista ja niiden lisätiedoista koostuva tiedosto
Halias_sp=read.csv("Halias_sp_v1.7.csv") # Halias_sp_v1.7.csv

# Haetaan tiedosto, jossa kerrottu mihin lajeihin lajilleen määrittämättömät taksonit voidaan yhdistää
sp_species=read.csv("Sp_species_1.7.csv") # Sp_species_1.7.csv
  
Halias$spLocal=Halias$Local
Halias$spMigr=Halias$Migr
Halias$spStand=Halias$Stand

#Halias$Migr=Halias$spMigr
#Halias$Local=Halias$spLocal

taxon=unique(as.character(sp_species$Taxon))

#taxN=data.frame(taxon)
#for(i in 1:length(taxon)){
#taxN$Nl[i]=nrow(Halias[which(Halias$Species_Abb==taxon[i] & Halias$Local>0),])
#taxN$Nm[i]=nrow(Halias[which(Halias$Species_Abb==taxon[i] & Halias$Migr>0),])
#}

# Käy läpi kaikki määrittämättömät taksonit ja lisätään nämä määritettyihin näiden määritysosuuksien 
# mukaan, tämä looppi kestää useita tunteja
for(i in 1:length(taxon)){
  #for(i in 52:length(taxon)){ 
  apu=sp_species[which(sp_species$Taxon==taxon[i]),]
  
  sp_loc=Halias[which(Halias$Species_Abb==taxon[i] & Halias$Local>0),]
  sp_mig=Halias[which(Halias$Species_Abb==taxon[i] & Halias$Migr>0),]
  
  # Jos kyseisen taksonin havaintojen jakaminen riippuu vuodenajasta ja jaettavia lajeja on useita
  if(length(unique(apu$Date1))>1 & length(unique(apu$Species))>1){ 
    
    if(nrow(sp_loc)>0){
      # käydään kaikki paikallishavikset läpi
      for(h in 1:nrow(sp_loc)){ 
        #for(h in 1:1){ 
        
        apup=sp_species[which(sp_species$Taxon==taxon[i] & sp_species$Date1<=sp_loc$Day.of.Year[h] & 
                                sp_species$Date2>=sp_loc$Day.of.Year[h] & sp_species$Type=="P"),]
        
        # jos jaettavia lajeja on vain yksi tässä vuodenaikaisjaksossa (esim. V -> clahye loppusyksystä)
        if(length(unique(apup$Species))==1){ 
          
          # jos saavalla lajilla on jo aikaisemmin havaintoja ko havaintopäivältä lisätään tähän havaintoriviin määrät
          if(length(which(Halias$Species_Abb==as.character(apup$Species[1]) & Halias$Day.of.Year==sp_loc$Day.of.Year[h] & Halias$Year==sp_loc$Year[h]))>0){
            
            Halias[which(Halias$Species_Abb==as.character(apup$Species[1]) & Halias$Day.of.Year==sp_loc$Day.of.Year[h] & Halias$Year==sp_loc$Year[h]),16]=
              Halias[which(Halias$Species_Abb==as.character(apup$Species[1]) & Halias$Day.of.Year==sp_loc$Day.of.Year[h] & Halias$Year==sp_loc$Year[h]),16]+sp_loc$Local[h]
            # jos saavalra lajilta ei ole aikaisemmin havaintoja ko havaintopäivältä tehdään uusi havaintorivi 
          }else if(length(which(Halias$Species_Abb==as.character(apup$Species[1]) & Halias$Day.of.Year==sp_loc$Day.of.Year[h] & Halias$Year==sp_loc$Year[h]))==0){
            
            rivi=sp_loc[h,]
            riviapu=Halias[which(Halias$Species_Abb==as.character(apup$Species[1])),]
            rivi[1,1:6]=riviapu[1,1:6]
            rivi[1,10:12]=0
            rivi[1,13]=NA
            rivi[1,16]=sp_loc$Local[h]
            rivi[1,17:18]=0
            Halias=rbind(Halias,rivi)
          } 
          
        }else if(length(unique(apup$Species))>1){
          
          # lasketaan kunkin jaettavan lajin runsaus lähipäivinä (painotettu keskiarvo)
          for(l in 1:nrow(apup)){
            #for(l in 1:1){
            apup$sum[l]=sum(sum(Halias[which(Halias$Species_Abb==as.character(apup$Species[l]) & Halias$Day.of.Year==sp_loc$Day.of.Year[h]-2 & Halias$Year==sp_loc$Year[h]),16])+
                              sum(Halias[which(Halias$Species_Abb==as.character(apup$Species[l]) & Halias$Day.of.Year==sp_loc$Day.of.Year[h]-1 & Halias$Year==sp_loc$Year[h]),16])*2+      
                              sum(Halias[which(Halias$Species_Abb==as.character(apup$Species[l]) & Halias$Day.of.Year==sp_loc$Day.of.Year[h] & Halias$Year==sp_loc$Year[h]),16])*3+
                              sum(Halias[which(Halias$Species_Abb==as.character(apup$Species[l]) & Halias$Day.of.Year==sp_loc$Day.of.Year[h]+1 & Halias$Year==sp_loc$Year[h]),16])*2+
                              sum(Halias[which(Halias$Species_Abb==as.character(apup$Species[l]) & Halias$Day.of.Year==sp_loc$Day.of.Year[h]+2 & Halias$Year==sp_loc$Year[h]),16]))/9
          }
          
          # jos edes jostakin jaettavasta lajista on havainto lähipäiviltä
          if(sum(apup$sum,na.rm = TRUE)>0){
            
            # jaetaan havainnot lajeille (lajien läpikäynti)
            for(l in 1:nrow(apup)){
              apup$ratio[l]=round(sum(apup$sum[l],na.rm=TRUE)/sum(apup$sum,na.rm=TRUE)*sp_loc$Local[h])
              
              # jos saavalla lajilla on jo aikaisemmin havaintoja ko havaintopäivältä lisätään tähän havaintoriviin määrät 
              if(length(which(Halias$Species_Abb==as.character(apup$Species[l]) & Halias$Day.of.Year==sp_loc$Day.of.Year[h] & Halias$Year==sp_loc$Year[h]))>0){
                
                Halias[which(Halias$Species_Abb==as.character(apup$Species[l]) & Halias$Day.of.Year==sp_loc$Day.of.Year[h] & Halias$Year==sp_loc$Year[h]),16]=
                  Halias[which(Halias$Species_Abb==as.character(apup$Species[l]) & Halias$Day.of.Year==sp_loc$Day.of.Year[h] & Halias$Year==sp_loc$Year[h]),16]+apup$ratio[l]
                
                # jos saavalta lajilta ei ole aikaisemmin havaintoja ko havaintopäivältä tehdään uusi havaintorivi 
              }else if(length(which(Halias$Species_Abb==as.character(apup$Species[l]) & Halias$Day.of.Year==sp_loc$Day.of.Year[h] & Halias$Year==sp_loc$Year[h]))==0 & apup$ratio[l]>0){
                rivi=sp_loc[h,]
                riviapu=Halias[which(Halias$Species_Abb==as.character(apup$Species[l])),]
                rivi[1,1:6]=riviapu[1,1:6]
                rivi[1,10:12]=0
                rivi[1,13]=NA
                rivi[1,16]=apup$ratio[l]
                rivi[1,17:18]=0
                Halias=rbind(Halias,rivi)
              }
            }
          }
        }
      }
    }
    # käydään kaikki muuttohavikset läpi 
    if(nrow(sp_mig)>0){
    for(h in 1:nrow(sp_mig)){ 
      #for(h in 1:1){
      
      apum=sp_species[which(sp_species$Taxon==taxon[i] & sp_species$Date1<=sp_mig$Day.of.Year[h] & 
                              sp_species$Date2>=sp_mig$Day.of.Year[h] & sp_species$Type=="M"),]
      
      # jos jaettavia lajeja on vain yksi tässä vuodenaikaisjaksossa (esim. V -> clahye loppusyksystä)
      if(length(unique(apum$Species))==1){ 
        
        # jos saavalla lajilla on jo aikaisemmin havaintoja ko havaintopäivältä lisätään tähän havaintoriviin määrät
        if(length(which(Halias$Species_Abb==as.character(apum$Species[1]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h] & Halias$Year==sp_mig$Year[h]))>0){
          #9  
          Halias[which(Halias$Species_Abb==as.character(apum$Species[1]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h] & Halias$Year==sp_mig$Year[h]),17]=
            Halias[which(Halias$Species_Abb==as.character(apum$Species[1]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h] & Halias$Year==sp_mig$Year[h]),17]+sp_mig$Migr[h]
          
          Halias[which(Halias$Species_Abb==as.character(apum$Species[1]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h] & Halias$Year==sp_mig$Year[h]),18]=
            Halias[which(Halias$Species_Abb==as.character(apum$Species[1]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h] & Halias$Year==sp_mig$Year[h]),18]+sp_mig$Stand[h]
          
          # jos saavalta lajilta ei ole aikaisemmin havaintoja ko havaintopäivältä tehdään uusi havaintorivi 
        }else if(length(which(Halias$Species_Abb==as.character(apum$Species[1]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h] & Halias$Year==sp_mig$Year[h]))==0 & sp_mig$Migr[h]>0){
          rivi=sp_mig[h,]
          riviapu=Halias[which(Halias$Species_Abb==as.character(apum$Species[1])),]
          rivi[1,1:6]=riviapu[1,1:6]
          rivi[1,10:12]=0
          rivi[1,13]=NA
          rivi[1,16]=0
          rivi[1,17]=sp_mig$Migr[h]
          rivi[1,18]=sp_mig$Stand[h]
          Halias=rbind(Halias,rivi)
        } 
        
      }else if(length(unique(apum$Species))>1){
        
        
        # lasketaan kunkin jaettavan lajin runsaus lähipäivinä (painotettu keskiarvo)
        for(l in 1:nrow(apum)){
          apum$sum[l]=sum(sum(Halias[which(Halias$Species_Abb==as.character(apum$Species[l]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h]-2 & Halias$Year==sp_mig$Year[h]),17])+
                            sum(Halias[which(Halias$Species_Abb==as.character(apum$Species[l]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h]-1 & Halias$Year==sp_mig$Year[h]),17])*2+      
                            sum(Halias[which(Halias$Species_Abb==as.character(apum$Species[l]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h] & Halias$Year==sp_mig$Year[h]),17])*3+
                            sum(Halias[which(Halias$Species_Abb==as.character(apum$Species[l]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h]+1 & Halias$Year==sp_mig$Year[h]),17])*2+
                            sum(Halias[which(Halias$Species_Abb==as.character(apum$Species[l]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h]+2 & Halias$Year==sp_mig$Year[h]),17]))/9
        }
        
        # jos edes jostakin jaettavasta lajista on havainto lähipäiviltä
        if(sum(apum$sum,na.rm = TRUE)>0){
          
          # jaetaan havainnot lajeille (lajien läpikäynti)
          for(l in 1:nrow(apum)){
            apum$ratio[l]=round(sum(apum$sum[l],na.rm=TRUE)/sum(apum$sum,na.rm=TRUE)*sp_mig$Migr[h])
            apum$ratiost[l]=round(sum(apum$sum[l],na.rm=TRUE)/sum(apum$sum,na.rm=TRUE)*sp_mig$Stand[h])
            
            # jos saavalla lajilla on jo aikaisemmin havaintoja ko havaintopäivältä lisätään tähän havaintoriviin määrät 
            if(length(which(Halias$Species_Abb==as.character(apum$Species[l]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h] & Halias$Year==sp_mig$Year[h]))>0){
              
              Halias[which(Halias$Species_Abb==as.character(apum$Species[l]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h] & Halias$Year==sp_mig$Year[h]),17]=
                Halias[which(Halias$Species_Abb==as.character(apum$Species[l]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h] & Halias$Year==sp_mig$Year[h]),17]+apum$ratio[l]
              
              Halias[which(Halias$Species_Abb==as.character(apum$Species[l]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h] & Halias$Year==sp_mig$Year[h]),18]=
                Halias[which(Halias$Species_Abb==as.character(apum$Species[l]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h] & Halias$Year==sp_mig$Year[h]),18]+apum$ratiost[l]
              
              # jos saavalta lajilta ei ole aikaisemmin havaintoja ko havaintopäivältä tehdään uusi havaintorivi  
            }else if(length(which(Halias$Species_Abb==as.character(apum$Species[l]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h] & Halias$Year==sp_mig$Year[h]))==0 & apum$ratio[l]>0){
              rivi=sp_mig[h,]
              riviapu=Halias[which(Halias$Species_Abb==as.character(apum$Species[l])),]
              rivi[1,1:6]=riviapu[1,1:6]
              rivi[1,10:12]=0
              rivi[1,13]=NA
              rivi[1,16]=0
              rivi[1,17]=apum$ratio[l]
              rivi[1,18]=apum$ratiost[l]
              Halias=rbind(Halias,rivi)
            }
          }
        }
      }
    }          
    }
    
    # Jos jaettavat lajit ovat samat koko vuoden ajan
  } else if(length(unique(apu$Date1))==1){
    
    # jos jaettavia lajeja on vain yksi (esim. strepto -> strtur )
    if(length(unique(apu$Species))==1){
      if(nrow(sp_loc)>0){
        # käydään kaikki paikallishavikset läpi
        for(h in 1:nrow(sp_loc)){
          #for(h in 1:1){
          
          # jos saavalla lajilla on jo aikaisemmin havaintoja ko havaintopäivältä lisätään tähän havaintoriviin määrät
          if(length(which(Halias$Species_Abb==as.character(apu$Species[l]) & Halias$Day.of.Year==sp_loc$Day.of.Year[h] & Halias$Year==sp_loc$Year[h]))>0){
            
            Halias[which(Halias$Species_Abb==as.character(apu$Species[l]) & Halias$Day.of.Year==sp_loc$Day.of.Year[h] & Halias$Year==sp_loc$Year[h]),16]=
              Halias[which(Halias$Species_Abb==as.character(apu$Species[l]) & Halias$Day.of.Year==sp_loc$Day.of.Year[h] & Halias$Year==sp_loc$Year[h]),16]+sp_loc$Local[h]
            
            # jos saavalta lajilta ei ole aikaisemmin havaintoja ko havaintopäivältä tehdään uusi havaintorivi 
          }else if(length(which(Halias$Species_Abb==as.character(apu$Species[l]) & Halias$Day.of.Year==sp_loc$Day.of.Year[h] & Halias$Year==sp_loc$Year[h]))==0){
            rivi=sp_loc[h,]
            riviapu=Halias[which(Halias$Species_Abb==as.character(apu$Species[1])),]
            rivi[1,1:6]=riviapu[1,1:6]
            rivi[1,10:12]=0
            rivi[1,13]=NA
            rivi[1,16]=sp_loc$Local[h]
            rivi[1,17:18]=0
            Halias=rbind(Halias,rivi)
          }
        }
      }
      # käydään kaikki muuttohavikset läpi
      if(nrow(sp_mig)>0){
      for(h in 1:nrow(sp_mig)){
        #for(h in 1:1){
        
        # jos saavalla lajilla on jo aikaisemmin havaintoja ko havaintopäivältä lisätään tähän havaintoriviin määrät
        if(length(which(Halias$Species_Abb==as.character(apu$Species[l]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h] & Halias$Year==sp_mig$Year[h]))>0){
          
          Halias[which(Halias$Species_Abb==as.character(apu$Species[l]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h] & Halias$Year==sp_mig$Year[h]),17]=
            Halias[which(Halias$Species_Abb==as.character(apu$Species[l]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h] & Halias$Year==sp_mig$Year[h]),17]+sp_mig$Migr[h]
          
          Halias[which(Halias$Species_Abb==as.character(apu$Species[l]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h] & Halias$Year==sp_mig$Year[h]),18]=
            Halias[which(Halias$Species_Abb==as.character(apu$Species[l]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h] & Halias$Year==sp_mig$Year[h]),18]+sp_mig$Stand[h]
          
          # jos saavalta lajilta ei ole aikaisemmin havaintoja ko havaintopäivältä tehdään uusi havaintorivi 
        }else if(length(which(Halias$Species_Abb==as.character(apu$Species[l]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h] & Halias$Year==sp_mig$Year[h]))==0){
          rivi=sp_mig[h,]
          riviapu=Halias[which(Halias$Species_Abb==as.character(apu$Species[1])),]
          rivi[1,1:6]=riviapu[1,1:6]
          rivi[1,10:12]=0
          rivi[1,13]=NA
          rivi[1,16]=0
          rivi[1,17]=sp_mig$Migr[h]
          rivi[1,18]=sp_mig$Stand[h]
          Halias=rbind(Halias,rivi)
        }
      }
      }
      # jos jaettavia lajeja on useampi
    } else if(length(unique(apu$Species))>1){
      if(nrow(sp_loc)>0){
        # käydään kaikki paikallishavikset läpi
        for(h in 1:nrow(sp_loc)){
          #for(h in 147:147){
          
          # lasketaan kunkin jaettavan lajin runsaus lähipäivinä (painotettu keskiarvo)
          for(l in 1:nrow(apu)){
            #for(l in 1:1){
            apu$sum[l]=sum(sum(Halias[which(Halias$Species_Abb==as.character(apu$Species[l]) & Halias$Day.of.Year==sp_loc$Day.of.Year[h]-2 & Halias$Year==sp_loc$Year[h]),16])+
                             sum(Halias[which(Halias$Species_Abb==as.character(apu$Species[l]) & Halias$Day.of.Year==sp_loc$Day.of.Year[h]-1 & Halias$Year==sp_loc$Year[h]),16])*2+      
                             sum(Halias[which(Halias$Species_Abb==as.character(apu$Species[l]) & Halias$Day.of.Year==sp_loc$Day.of.Year[h] & Halias$Year==sp_loc$Year[h]),16])*3+
                             sum(Halias[which(Halias$Species_Abb==as.character(apu$Species[l]) & Halias$Day.of.Year==sp_loc$Day.of.Year[h]+1 & Halias$Year==sp_loc$Year[h]),16])*2+
                             sum(Halias[which(Halias$Species_Abb==as.character(apu$Species[l]) & Halias$Day.of.Year==sp_loc$Day.of.Year[h]+2 & Halias$Year==sp_loc$Year[h]),16]))/9
          }
          # jos edes jostakin jaettavasta lajista on havainto lähipäiviltä
          if(sum(apu$sum,na.rm = TRUE)>0){
            
            # jaetaan havainnot lajeille (lajien läpikäynti)
            for(l in 1:nrow(apu)){
              apu$ratio[l]=round(apu$sum[l]/sum(apu$sum,na.rm=TRUE)*sp_loc$Local[h])
              
              # jos saavalla lajilla on jo aikaisemmin havaintoja ko havaintopäivältä lisätään tähän havaintoriviin määrät 
              if(length(which(Halias$Species_Abb==as.character(apu$Species[l]) & Halias$Day.of.Year==sp_loc$Day.of.Year[h] & Halias$Year==sp_loc$Year[h]))>0){
                
                Halias[which(Halias$Species_Abb==as.character(apu$Species[l]) & Halias$Day.of.Year==sp_loc$Day.of.Year[h] & Halias$Year==sp_loc$Year[h]),16]=
                  Halias[which(Halias$Species_Abb==as.character(apu$Species[l]) & Halias$Day.of.Year==sp_loc$Day.of.Year[h] & Halias$Year==sp_loc$Year[h]),16]+apu$ratio[l]
                
                # jos saavalta lajilta ei ole aikaisemmin havaintoja ko havaintopäivältä tehdään uusi havaintorivi 
              }else if(length(which(Halias$Species_Abb==as.character(apu$Species[l]) & Halias$Day.of.Year==sp_loc$Day.of.Year[h] & Halias$Year==sp_loc$Year[h]))==0 & apu$ratio[l]>0){
                rivi=sp_loc[h,]
                riviapu=Halias[which(Halias$Species_Abb==as.character(apu$Species[l])),]
                rivi[1,1:6]=riviapu[1,1:6]
                rivi[1,10:12]=0
                rivi[1,13]=NA
                rivi[1,16]=apu$ratio[l]
                rivi[1,17:18]=0
                Halias=rbind(Halias,rivi)
              }
            }
          }
        }
      }
      #}
      if(nrow(sp_mig)>0){
      # käydään kaikki muuttohavikset läpi
      
      for(h in 1:nrow(sp_mig)){
        #for(h in 1:1){
        
        # lasketaan kunkin jaettavan lajin runsaus lähipäivinä (painotettu keskiarvo)
        for(l in 1:nrow(apu)){
          apu$sum[l]=sum(sum(Halias[which(Halias$Species_Abb==as.character(apu$Species[l]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h]-2 & Halias$Year==sp_mig$Year[h]),17])+
                           sum(Halias[which(Halias$Species_Abb==as.character(apu$Species[l]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h]-1 & Halias$Year==sp_mig$Year[h]),17])*2+      
                           sum(Halias[which(Halias$Species_Abb==as.character(apu$Species[l]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h] & Halias$Year==sp_mig$Year[h]),17])*3+
                           sum(Halias[which(Halias$Species_Abb==as.character(apu$Species[l]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h]+1 & Halias$Year==sp_mig$Year[h]),17])*2+
                           sum(Halias[which(Halias$Species_Abb==as.character(apu$Species[l]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h]+2 & Halias$Year==sp_mig$Year[h]),17]))/9
        }
        # jos edes jostakin jaettavasta lajista on havainto lähipäiviltä
        if(sum(apu$sum,na.rm = TRUE)>0){
          
          # jaetaan havainnot lajeille (lajien läpikäynti)
          for(l in 1:nrow(apu)){
            apu$ratio[l]=round(sum(apu$sum[l],na.rm=TRUE)/sum(apu$sum,na.rm=TRUE)*sp_mig$Migr[h])
            apu$ratiost[l]=round(sum(apu$sum[l],na.rm=TRUE)/sum(apu$sum,na.rm=TRUE)*sp_mig$Stand[h])
            
            # jos saavalla lajilla on jo aikaisemmin havaintoja ko havaintopäivältä lisätään tähän havaintoriviin määrät 
            if(length(which(Halias$Species_Abb==as.character(apu$Species[l]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h] & Halias$Year==sp_mig$Year[h]))>0){
              
              Halias[which(Halias$Species_Abb==as.character(apu$Species[l]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h] & Halias$Year==sp_mig$Year[h]),17]=
                Halias[which(Halias$Species_Abb==as.character(apu$Species[l]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h] & Halias$Year==sp_mig$Year[h]),17]+apu$ratio[l]
              
              Halias[which(Halias$Species_Abb==as.character(apu$Species[l]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h] & Halias$Year==sp_mig$Year[h]),18]=
                Halias[which(Halias$Species_Abb==as.character(apu$Species[l]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h] & Halias$Year==sp_mig$Year[h]),18]+apu$ratiost[l]
              
              # jos saavalta lajilta ei ole aikaisemmin havaintoja ko havaintopäivältä tehdään uusi havaintorivi 
            }else if(length(which(Halias$Species_Abb==as.character(apu$Species[l]) & Halias$Day.of.Year==sp_mig$Day.of.Year[h] & Halias$Year==sp_mig$Year[h]))==0 & apu$ratio[l]>0){
              rivi=sp_mig[h,]
              riviapu=Halias[which(Halias$Species_Abb==as.character(apu$Species[l])),]
              rivi[1,1:6]=riviapu[1,1:6]
              rivi[1,10:12]=0
              rivi[1,13]=NA
              rivi[1,16]=0
              rivi[1,17]=apu$ratio[l]
              rivi[1,18]=apu$ratiost[l]
              Halias=rbind(Halias,rivi)
            }
          }
          }
        }
      }
    }
  }
}  
setwd("/Users/aleksilehikoinen/R/Halias")
write.csv(Halias,"Halias_2023.csv",row.names=FALSE)

# Seuraava käskyjoukko tuottaa kolmiosaisen kuvaajan, jossa ylin kuvaaja kertoo paikallismäärien
# vaihtelun vuoden aikana ja keskimmäinen muuttajien vastaavan vaihtelun. Kuvaajissa x-akselilla on päivämäärä 1.1.-31.12. 
# Kolmas kuvaaja kertoo paikallisten ja muuttajien yhdistetyn runsauden ennen vuotta 2000 (sininen viiva) 
# ja vuoden 2009 jälkeen (punainen viiva). Näiden avulla käyrien avulla voi tarkastelajin havaintomäärissä 
# tapahtuneita pitkäaikaisia muutoksia.

# Following code will draw a figure with three panels of the selected species. 
# The upper panel shows the mean counts of local birds per each calendar day over the years.
# The middle panel shows the mean migration counts per each calendar day over the years.
# The lowest panel shows combined mean daily abundances (locals and migrants) during the beginning of the study 
# period 1979-1999 (blue line) and since 2009 (red line). 
# The panel visualise potential long-term changes in abundance of the selected species.

Halias_SP=Halias_sp[which(Halias_sp$Sp==1 & Halias_sp$Species_code<1000),]

Halias$Species_code=as.numeric(as.character(Halias$Species_code))

#Haliasvali <- Halias[which(Halias$Additional==0),]
Haliasvali <- Halias[which(Halias$Additional>0 & Halias$Species_code>469),]
Haliasvali$lisaP <- Haliasvali$spLocal+Haliasvali$Additional
Haliasvali2 <- Halias[which(is.na(Halias$Additional==TRUE)),]
Haliasvali2$lisaP <-Haliasvali2$Local
Halias <- rbind(Haliasvali, Haliasvali2)

# Hae lajilistaus / download list of species

Haliasvali <- Halias[which(Halias$Night_migr>-1),]
Haliasvali$lisaM <- Haliasvali$spMigr+Haliasvali$Night_migr
Haliasvali2 <- Halias[which(is.na(Halias$Night_migr==TRUE)),]
Haliasvali2$lisaM <-NA
Halias <- rbind(Haliasvali, Haliasvali2)


trend=list()
spring=matrix(NA,nrow=0,ncol=2)
colnames(spring)=c("sp","date")

autumn=matrix(NA,nrow=0,ncol=2)
colnames(autumn)=c("sp","date")

tphen=matrix(NA,ncol=366,nrow=1)
doy=as.Date(1:366, origin="1999-12-31")
colnames(tphen)=as.character(doy)
tphen=as.data.frame(tphen)
tphen$type=NA
tphen$sp=NA


#Valitse hakemisto, johon kuvaajat tehdään
#Set working directory where the figures will be made
setwd("/users/aleksilehikoinen/R/Halias/Sp")

for(l in 1:nrow(Halias_SP)){
#for(l in 28:28){
  
  # Valitse laji ja kirjoita se lainausmerkkien sisään (tässä tukkasotka AYTFUL).
  # Choose a species and write it between the quotation marks (here tufted duck AYTFUL).
  #sp <- c("AEGCAU") # 
  
  sp <- as.character(Halias_SP$Species_Abb[l])
  
  # Jos lajin lisäpaikalliset soveltuu paikalliskuvaajaan niin käytetään myös lisäaluetta (rarit)
  if((Halias_SP$Add[l]) > 0){
    Halias$P=Halias$lisaP
  } else {
    Halias$P=Halias$spLocal
  }
  
  # Jos lajin yömuuttavat soveltuu muuttokuvaajaan niin käytetään myös yöm (Botste)
  
  if((Halias_SP$Night[l]) > 0){
    Halias$M=Halias$lisaM
  } else {
    Halias$M=Halias$spMigr
  }
  
  # Seuraava käskyjoukko tuottaa kolmiosaisen kuvaajan, jossa ylin kuvaaja kertoo paikallismäärien
  # vaihtelun vuoden aikana ja keskimmäinen muuttajien vastaavan vaihtelun. Kuvaajissa x-akselilla on
  # juokseva päivämäärä (1.1. = 1 jne). Kolmas kuvaaja kertoo paikallisten ja muuttajien yhdistetyn
  # runsauden ennen vuotta 2000 (sininen viiva) ja vuoden 2009 jälkeen (punainen viiva). Näiden avulla
  # käyrien avulla voi tarkastelajin havaintomäärissä tapahtuneita pitkäaikaisia muutoksia.
  
  phen <- data.frame(day = 1:366, paik = NA_real_, muutto = 0,
                     paikbegin = NA_real_, muuttobegin = 0,
                     paikend = NA_real_, muuttoend = 0)
  apusp <- Halias$Species_Abb == sp
  apulow <- Halias$Year < 2000
  apumed <- Halias$Year > 1999 & Halias$Year <2010
  apuhigh <- Halias$Year > 2009
  apusplow <- apusp & apulow
  apuspmed <- apusp & apumed
  apusphigh <- apusp & apuhigh
  for(i in 1:366) {
    apudoy <- Halias$Day.of.Year == i
    apuspdoy <- apusp & apudoy
    apuspdoyobs <- apuspdoy & Halias$Observed
    
    apup <- Halias$P[which(apuspdoy & !Halias$Observed)]
    apum <- Halias$M[which(apuspdoy)]
    idxbegin <- which(apusplow & apudoy)
    idxmed <- which(apuspmed & apudoy)
    idxend <- which(apusphigh & apudoy)
    apupbegin <- Halias$P[idxbegin]
    apupmed <- Halias$P[idxmed]
    apupend <- Halias$P[idxend]
    apumbegin <- Halias$M[idxbegin]
    apummed <- Halias$M[idxmed]
    apumend <- Halias$M[idxend]
    
    apuhp <- Halias$Year[which(apudoy)]
    apuhp2 <- which(apuspdoyobs)
    apuhpbegin <- Halias$Year[which(apudoy & apulow)]
    apuhp2begin <- Halias$P[which(apuspdoyobs & apulow)]
    apuhpmed <- Halias$Year[which(apudoy & apumed)]
    apuhp2med <- Halias$P[which(apuspdoyobs & apumed)]
    apuhpend <- Halias$Year[which(apudoy & apuhigh)]
    apuhp2end <- Halias$P[which(apuspdoyobs & apuhigh)]
    
    apuHM <- length(unique(apuhp))
    apuHP <- apuHM - length(apuhp2)
    apuHMbegin <- length(unique(apuhpbegin))
    apuHPbegin <- apuHMbegin - length(apuhp2begin)
    apuHMmed <- length(unique(apuhpmed))
    apuHPmed <- apuHMmed - length(apuhp2med)
    apuHMend <- length(unique(apuhpend))
    apuHPend <- apuHMend - length(apuhp2end)
    
    # Locals whole period
    if(length(apuHP) > 0) {
      phen$paik[i] <- sum(apup) / apuHP
    }
    
    # Migrants whole period
    if(length(apuHM) > 0) {
      phen$muutto[i] <- sum(apum) / apuHM
    }
    
    # Locals beginning of the period
    if(length(apuHPbegin) > 0) {
      phen$paikbegin[i] <- sum(apupbegin) / apuHPbegin
    }
    
    # Migrants beginning of the period
    if(length(apuHMbegin) > 0) {
      phen$muuttobegin[i] <- sum(apumbegin) / apuHMbegin
    }
    # Locals med of the period
    if(length(apuHPmed) > 0) {
      phen$paikmed[i] <- sum(apupmed) / apuHPmed
    }
    
    # Migrants med of the period
    if(length(apuHMmed) > 0) {
      phen$muuttomed[i] <- sum(apummed) / apuHMmed
    }
    # Locals end of the period
    if(length(apuHPend) > 0) {
      phen$paikend[i] <- sum(apupend) / apuHPend
    }
    
    # Migrants end of the period
    if(length(apuHMend) > 0) {
      phen$muuttoend[i] <- sum(apumend) / apuHMend
    }
  }
  
  if(Halias_SP$Trend[l]==1){
    
    phen$begin <- phen$muuttobegin
    phen$med <- phen$muuttomed
    phen$end <- phen$muuttoend
    
  }else if(Halias_SP$Trend[l]==2){
  phen$begin <- phen$paikbegin + phen$muuttobegin
  phen$med <- phen$paikmed + phen$muuttomed
  phen$end <- phen$paikend + phen$muuttoend
  }
  phen$day <- as.Date(phen$day - 1, origin = "2000-01-01")
  
  N=list()
  N$begin = sum(phen[which(phen$begin>0),10])
  N$med = sum(phen[which(phen$med>0),11])
  N$end = sum(phen[which(phen$end>0),12])
  
  
  # Fenologia muutokset
  Phen=list()
  
  if(Halias_SP$P[l] == 1 & Halias_SP$M[l] ==0){
    Phen$begin <- phen$paikbegin 
    Phen$med <- phen$paikmed
    Phen$end <- phen$paikend
    
  } else if(Halias_SP$P[l] == 0 & Halias_SP$M[l] ==1) {
    Phen$begin <- phen$muuttobegin 
    Phen$med <- phen$muuttomed
    Phen$end <- phen$muuttoend
    
  }else if(Halias_SP$P[l] == 1 & Halias_SP$M[l]==1) {
    Phen$begin <- phen$paikbegin + phen$muuttobegin
    Phen$med <- phen$paikmed + phen$muuttomed
    Phen$end <- phen$paikend + phen$muuttoend
  }
  
  PHENs=data.frame()
for(dt in Halias_SP$SpB[l]:Halias_SP$SpE[l]){
  PH=c(dt, 
       sum(Phen$begin[Halias_SP$SpB[l]:dt],na.rm=TRUE)/sum(Phen$begin[Halias_SP$SpB[l]:Halias_SP$SpE[l]],na.rm=TRUE),
       sum(Phen$med[Halias_SP$SpB[l]:dt])/sum(Phen$med[Halias_SP$SpB[l]:Halias_SP$SpE[l]]),
       sum(Phen$end[Halias_SP$SpB[l]:dt])/sum(Phen$end[Halias_SP$SpB[l]:Halias_SP$SpE[l]]) )

  PHENs=rbind(PHENs,PH)
       
}
  colnames(PHENs) <- c("dt","begin","med","end")

  PHENa=data.frame()
  
if(Halias_SP$AuE[l]>70){
  
  for(dt in Halias_SP$AuB[l]:Halias_SP$AuE[l]){
    PH=c(dt, 
        sum(Phen$begin[Halias_SP$AuB[l]:dt],na.rm=TRUE)/sum(Phen$begin[Halias_SP$AuB[l]:Halias_SP$AuE[l]],na.rm=TRUE),
        sum(Phen$med[Halias_SP$AuB[l]:dt])/sum(Phen$med[Halias_SP$AuB[l]:Halias_SP$AuE[l]]),
        sum(Phen$end[Halias_SP$AuB[l]:dt])/sum(Phen$end[Halias_SP$AuB[l]:Halias_SP$AuE[l]]) )
    
    PHENa=rbind(PHENa,PH)

  }    
}else if(Halias_SP$AuE[l]<70){
 
  for(dt in Halias_SP$AuB[l]:366){
    PH=c(dt, 
         sum(Phen$begin[Halias_SP$AuB[l]:dt],na.rm=TRUE)/
           (sum(Phen$begin[1:Halias_SP$AuE[l]],na.rm=TRUE)+sum(Phen$begin[Halias_SP$AuB[l]:366],na.rm=TRUE)),
         sum(Phen$med[Halias_SP$AuB[l]:dt])/
           (sum(Phen$med[1:Halias_SP$AuE[l]],na.rm=TRUE)+sum(Phen$med[Halias_SP$AuB[l]:366],na.rm=TRUE)),
         sum(Phen$end[Halias_SP$AuB[l]:dt])/
           (sum(Phen$end[1:Halias_SP$AuE[l]],na.rm=TRUE)+sum(Phen$end[Halias_SP$AuB[l]:366],na.rm=TRUE)))
    
    PHENa=rbind(PHENa,PH)
  }    
  for(dt in 1:Halias_SP$AuE[l]){
    PH=c(366+dt, 
         (sum(Phen$begin[1:dt],na.rm=TRUE)+sum(Phen$begin[Halias_SP$AuB[l]:366],na.rm=TRUE))/
         (sum(Phen$begin[1:Halias_SP$AuE[l]],na.rm=TRUE)+sum(Phen$begin[Halias_SP$AuB[l]:366],na.rm=TRUE)),
         
         (sum(Phen$med[1:dt],na.rm=TRUE)+sum(Phen$med[Halias_SP$AuB[l]:366],na.rm=TRUE))/
         (sum(Phen$med[1:Halias_SP$AuE[l]],na.rm=TRUE)+sum(Phen$med[Halias_SP$AuB[l]:366],na.rm=TRUE)),
         
         (sum(Phen$end[1:dt],na.rm=TRUE)+sum(Phen$end[Halias_SP$AuB[l]:366],na.rm=TRUE))/
         (sum(Phen$end[1:Halias_SP$AuE[l]],na.rm=TRUE)+sum(Phen$end[Halias_SP$AuB[l]:366],na.rm=TRUE)))
    
    PHENa=rbind(PHENa,PH)
  }
}

colnames(PHENa) <- c("dt","begin","med","end")
  
SPHEN=list()
sphen=matrix(NA,nrow=0,ncol=10)
colnames(sphen)=c("sp","begin","begin5","begin95","med","med5","med95","end","end5","end95")
sphen=as.list(sphen)

if(sum(Phen$begin[Halias_SP$SpB[l]:Halias_SP$SpE[l]],na.rm=TRUE)>1 & 
   sum(Phen$med[Halias_SP$SpB[l]:Halias_SP$SpE[l]])>1 &
   sum(Phen$end[Halias_SP$SpB[l]:Halias_SP$SpE[l]])>1){
SPHEN$begin=min(PHENs[which(PHENs$begin>0.5),1])
SPHEN$med=min(PHENs[which(PHENs$med>0.5),1])
SPHEN$end=min(PHENs[which(PHENs$end>0.5),1])
SPHEN$begin5=min(PHENs[which(PHENs$begin>0.05),1])
SPHEN$med5=min(PHENs[which(PHENs$med>0.05),1])
SPHEN$end5=min(PHENs[which(PHENs$end>0.05),1])
SPHEN$begin95=min(PHENs[which(PHENs$begin>0.95),1])
SPHEN$med95=min(PHENs[which(PHENs$med>0.95),1])
SPHEN$end95=min(PHENs[which(PHENs$end>0.95),1])

sphen$sp[1]=as.character(Halias_SP$Species_Abb[l])
sphen$begin[1]=SPHEN$begin
sphen$med[1]=SPHEN$med
sphen$end[1]=SPHEN$end
sphen$begin5[1]=SPHEN$begin5
sphen$med5[1]=SPHEN$med5
sphen$end5[1]=SPHEN$end5
sphen$begin95[1]=SPHEN$begin95
sphen$med95[1]=SPHEN$med95
sphen$end95[1]=SPHEN$end95
sphen=as.data.frame(sphen)

alku= main=paste("1979-1999", format(strptime(SPHEN$begin, format="%j"), format="%m-%d"))
keski= main=paste("2000-2009", format(strptime(SPHEN$med, format="%j"), format="%m-%d"))
loppu= main=paste("2010-", format(strptime(SPHEN$end, format="%j"), format="%m-%d"))
} else{
  alku= main=paste("1979-1999")
  keski= main=paste("2000-2009")
  loppu= main=paste("2010-")
}

APHEN=list()
aphen=matrix(NA,nrow=0,ncol=10)
colnames(aphen)=c("sp","begin","begin5","begin95","med","med5","med95","end","end5","end95")
aphen=as.list(aphen)

if(sum(Phen$begin[Halias_SP$AuB[l]:366],na.rm=TRUE)>1 & 
   sum(Phen$med[Halias_SP$AuB[l]:366],na.rm=TRUE)>1 &
   sum(Phen$end[Halias_SP$AuB[l]:366],na.rm=TRUE)>1){
  APHEN$begin=min(PHENa[which(PHENa$begin>0.5),1])
  APHEN$med=min(PHENa[which(PHENa$med>0.5),1])
  APHEN$end=min(PHENa[which(PHENa$end>0.5),1])
  APHEN$begin5=min(PHENa[which(PHENa$begin>0.05),1])
  APHEN$med5=min(PHENa[which(PHENa$med>0.05),1])
  APHEN$end5=min(PHENa[which(PHENa$end>0.05),1])
  APHEN$begin95=min(PHENa[which(PHENa$begin>0.95),1])
  APHEN$med95=min(PHENa[which(PHENa$med>0.95),1])
  APHEN$end95=min(PHENa[which(PHENa$end>0.95),1])
  
  
  aphen$sp[1]=as.character(Halias_SP$Species_Abb[l])
  aphen$begin[1]=APHEN$begin
  aphen$med[1]=APHEN$med
  aphen$end[1]=APHEN$end
  aphen$begin5[1]=APHEN$begin5
  aphen$med5[1]=APHEN$med5
  aphen$end5[1]=APHEN$end5
  aphen$begin95[1]=APHEN$begin95
  aphen$med95[1]=APHEN$med95
  aphen$end95[1]=APHEN$end95
  aphen=as.data.frame(aphen)
  
  spring=rbind(spring,sphen)
  
  autumn=rbind(autumn,aphen)
}

  
  spSCI=unique(Halias[which(Halias$Species_Abb==sp),4])
  
  root=paste("/Users/aleksilehikoinen/R/Halias/Sp/", sp, ".pdf", sep="")
  
  pdf(file = root )
  
  par(mfrow=c(3, 1))
  
  plot(phen$day, phen$paik, type="l", main=paste(spSCI, ", Paikalliset / Stationära / Locals", sep=""),
       xlab="Day of Year", ylab="Yks./pvm - Ind./day")
  plot(phen$day, phen$muutto, type="l", main="Muuttavat / Flyttande / Migrants",
       xlab="Day of Year", ylab="Yks./pvm - Ind./day")
  
  apuphen <- which(phen$begin > -1)
  
  if(max(phen$begin[apuphen],na.rm = TRUE) >= max(phen$end[apuphen],na.rm = TRUE) & 
     max(phen$begin[apuphen],na.rm = TRUE) >= max(phen$med[apuphen],na.rm = TRUE) & 
     sum(phen$med,na.rm = TRUE)>0) {
    
    plot(phen$day, phen$begin, col="blue", type="l", 
         main=paste("Runsauden muutos / Förändring i antal / Change in abundance long ",
                    round((N$end/N$begin-1)*100) , "%, short ",round((N$end/N$med-1)*100), "%",sep=""),
         xlab="Day of Year", ylab="Yks./pvm - Ind./day")
    lines(phen$day, phen$end, col="red")
    lines(phen$day, phen$med, col="cyan")
    text(as.Date(30,origin = "2000-01-01"),max(phen$begin[apuphen])*0.95, alku, col="blue")
    text(as.Date(30,origin = "2000-01-01"),max(phen$begin[apuphen])*0.83,keski,col="cyan")
     text(as.Date(23.5,origin = "2000-01-01"),max(phen$begin[apuphen])*0.71,loppu,col="red")
    
  } else if(max(phen$begin[apuphen],na.rm = TRUE) >= max(phen$end[apuphen],na.rm = TRUE) &
            max(phen$begin[apuphen],na.rm = TRUE) >= max(phen$med[apuphen],na.rm = TRUE) &
            sum(phen$med,na.rm = TRUE)==0) {
    
    plot(phen$day, phen$begin, col="blue", type="l", 
         main=paste("Runsauden muutos / Förändring i antal / Change in abundance long ",
                    round((N$end/N$begin-1)*100) , "%",sep=""),
         xlab="Day of Year", ylab="Yks./pvm - Ind./day")
    lines(phen$day, phen$end, col="red")
    lines(phen$day, phen$med, col="cyan")
    text(as.Date(30,origin = "2000-01-01"),max(phen$begin[apuphen])*0.95,alku,col="blue")
    text(as.Date(30,origin = "2000-01-01"),max(phen$begin[apuphen])*0.83,keski,col="cyan")
    text(as.Date(23.5,origin = "2000-01-01"),max(phen$begin[apuphen])*0.71,loppu,col="red")
    
  } else if(max(phen$begin[apuphen],na.rm = TRUE) > max(phen$end[apuphen],na.rm = TRUE) &
            max(phen$begin[apuphen],na.rm = TRUE) < max(phen$med[apuphen],na.rm = TRUE) &
            sum(phen$begin,na.rm = TRUE)>0) {
    plot(phen$day, phen$med, col="cyan", type="l", 
         main=paste("Runsauden muutos / Förändring i antal / Change in abundance long ",
                    round((N$end/N$begin-1)*100) , "%, short ",round((N$end/N$med-1)*100), "%",sep=""),
         xlab="Day of Year", ylab="Yks./pvm - Ind./day")
    lines(phen$day, phen$begin, col="blue")
    lines(phen$day, phen$end, col="red")
    text(as.Date(30,origin = "2000-01-01"),max(phen$med[apuphen])*0.95,alku,col="blue")
    text(as.Date(30,origin = "2000-01-01"),max(phen$med[apuphen])*0.83,keski,col="cyan")
    text(as.Date(23.5,origin = "2000-01-01"),max(phen$med[apuphen])*0.71,loppu,col="red")
    
  }  else if(max(phen$end[apuphen],na.rm = TRUE) <= max(phen$med[apuphen],na.rm = TRUE) &
             max(phen$begin[apuphen],na.rm = TRUE) < max(phen$med[apuphen],na.rm = TRUE) &
             sum(phen$begin,na.rm = TRUE)>0) {
    plot(phen$day, phen$med, col="cyan", type="l", 
         main=paste("Runsauden muutos / Förändring i antal / Change in abundance long ",
                    round((N$end/N$begin-1)*100) , "%, short ",round((N$end/N$med-1)*100), "%",sep=""),
         xlab="Day of Year", ylab="Yks./pvm - Ind./day")
    lines(phen$day, phen$begin, col="blue")
    lines(phen$day, phen$end, col="red")
    text(as.Date(30,origin = "2000-01-01"),max(phen$med[apuphen])*0.95,alku,col="blue")
    text(as.Date(30,origin = "2000-01-01"),max(phen$med[apuphen])*0.83,keski,col="cyan")
    text(as.Date(23.5,origin = "2000-01-01"),max(phen$med[apuphen])*0.71,loppu,col="red")
  
  }  else if(max(phen$begin[apuphen],na.rm = TRUE) < max(phen$med[apuphen],na.rm = TRUE) &
             max(phen$end[apuphen],na.rm = TRUE) < max(phen$begin[apuphen],na.rm = TRUE)) {
    plot(phen$day, phen$med, col="cyan", type="l", 
         main=paste("Runsauden muutos / Förändring i antal / Change in abundance long ",
                    round((N$end/N$begin-1)*100) , "%, short ",round((N$end/N$med-1)*100), "%",sep=""),
         xlab="Day of Year", ylab="Yks./pvm - Ind./day")
    lines(phen$day, phen$begin, col="blue")
    lines(phen$day, phen$end, col="red")
    text(as.Date(30,origin = "2000-01-01"),max(phen$med[apuphen])*0.95,alku,col="blue")
    text(as.Date(30,origin = "2000-01-01"),max(phen$med[apuphen])*0.83,keski,col="cyan")
    text(as.Date(23.5,origin = "2000-01-01"),max(phen$med[apuphen])*0.71,loppu,col="red")
      
  } else if(max(phen$med[apuphen],na.rm = TRUE) < max(phen$end[apuphen],na.rm = TRUE) &
            max(phen$begin[apuphen],na.rm = TRUE) < max(phen$end[apuphen],na.rm = TRUE) &
            sum(phen$begin,na.rm = TRUE)>0 & sum(phen$med,na.rm = TRUE)>0) {
    plot(phen$day, phen$end, col="red", type="l", 
         main=paste("Runsauden muutos / Förändring i antal / Change in abundance long ",round((N$end/N$begin-1)*100) , "%, short ",round((N$end/N$med-1)*100), "%",sep=""),
         xlab="Day of Year", ylab="Yks./pvm - Ind./day")
    lines(phen$day, phen$begin, col="blue")
    lines(phen$day, phen$med, col="cyan")
    text(as.Date(30,origin = "2000-01-01"),max(phen$end[apuphen])*0.95,alku,col="blue")
    text(as.Date(30,origin = "2000-01-01"),max(phen$end[apuphen])*0.83,keski,col="cyan")
    text(as.Date(23.5,origin = "2000-01-01"),max(phen$end[apuphen])*0.71,loppu,col="red")
    
  }else if(max(phen$med[apuphen],na.rm = TRUE) < max(phen$end[apuphen],na.rm = TRUE) &
           max(phen$begin[apuphen],na.rm = TRUE) < max(phen$end[apuphen],na.rm = TRUE) &
           sum(phen$begin,na.rm = TRUE)>0 & sum(phen$med,na.rm = TRUE)==0) {
    plot(phen$day, phen$end, col="red", type="l", 
         main=paste("Runsauden muutos / Förändring i antal / Change in abundance long ",round((N$end/N$begin-1)*100) , "%",sep=""),
         xlab="Day of Year", ylab="Yks./pvm - Ind./day")
    lines(phen$day, phen$begin, col="blue")
    lines(phen$day, phen$med, col="cyan")
    text(as.Date(30,origin = "2000-01-01"),max(phen$end[apuphen])*0.95,alku,col="blue")
    text(as.Date(30,origin = "2000-01-01"),max(phen$end[apuphen])*0.83,keski,col="cyan")
    text(as.Date(23.5,origin = "2000-01-01"),max(phen$end[apuphen])*0.71,loppu,col="red")
    
  }
  
  else if(max(phen$med[apuphen],na.rm = TRUE) < max(phen$end[apuphen],na.rm = TRUE) &
          max(phen$begin[apuphen],na.rm = TRUE) < max(phen$end[apuphen],na.rm = TRUE) &
          sum(phen$begin,na.rm = TRUE)==0 & sum(phen$med,na.rm = TRUE)==0){
    plot(phen$day, phen$end, col="red", type="l", main="Runsauden muutos / Förändring i antal / Change in abundance",
         xlab="Day of Year", ylab="Yks./pvm - Ind./day")
    lines(phen$day, phen$begin, col="blue")
    lines(phen$day, phen$med, col="cyan")
    text(as.Date(30,origin = "2000-01-01"),max(phen$end[apuphen])*0.95,alku,col="blue")
    text(as.Date(30,origin = "2000-01-01"),max(phen$end[apuphen])*0.83,keski,col="cyan")
    text(as.Date(23.5,origin = "2000-01-01"),max(phen$end[apuphen])*0.71,loppu,col="red")
    
    
  }  else if(max(phen$med[apuphen],na.rm = TRUE) < max(phen$end[apuphen],na.rm = TRUE) &
             max(phen$begin[apuphen],na.rm = TRUE) < max(phen$end[apuphen],na.rm = TRUE) &
             sum(phen$begin,na.rm = TRUE)==0 & sum(phen$med,na.rm = TRUE)>0){
    plot(phen$day, phen$end, col="red", type="l", main=paste("Runsauden muutos / Förändring i antal / Change in abundance short ",round((N$end/N$med-1)*100), "%",sep=""),
         xlab="Day of Year", ylab="Yks./pvm - Ind./day")
    lines(phen$day, phen$begin, col="blue")
    lines(phen$day, phen$med, col="cyan")
    text(as.Date(30,origin = "2000-01-01"),max(phen$end[apuphen])*0.95,alku,col="blue")
    text(as.Date(30,origin = "2000-01-01"),max(phen$end[apuphen])*0.83,keski,col="cyan")
    text(as.Date(23.5,origin = "2000-01-01"),max(phen$end[apuphen])*0.71,loppu,col="red")
    
    
  } else if(max(phen$med[apuphen],na.rm = TRUE) > max(phen$end[apuphen],na.rm = TRUE) &
            max(phen$begin[apuphen],na.rm = TRUE) < max(phen$end[apuphen],na.rm = TRUE) &
            sum(phen$begin,na.rm = TRUE)==0){
    plot(phen$day, phen$med, col="cyan", type="l", main=paste("Runsauden muutos / Förändring i antal / Change in abundance short ",round((N$end/N$med-1)*100), "%",sep=""),
         xlab="Day of Year", ylab="Yks./pvm - Ind./day")
    lines(phen$day, phen$begin, col="blue")
    lines(phen$day, phen$end, col="red")
    text(as.Date(30,origin = "2000-01-01"),max(phen$med[apuphen])*0.95,alku,col="blue")
    text(as.Date(30,origin = "2000-01-01"),max(phen$med[apuphen])*0.83,keski,col="cyan")
    text(as.Date(23.5,origin = "2000-01-01"),max(phen$med[apuphen])*0.71,loppu,col="red")
    
    
  }  else if(max(phen$med[apuphen],na.rm = TRUE) > max(phen$end[apuphen],na.rm = TRUE) &
             max(phen$begin[apuphen],na.rm = TRUE) == max(phen$end[apuphen],na.rm = TRUE) &
             sum(phen$begin,na.rm = TRUE)==0){
    plot(phen$day, phen$med, col="cyan", type="l", main=paste("Runsauden muutos / Förändring i antal / Change in abundance short ",round((N$end/N$med-1)*100), "%",sep=""),
         xlab="Day of Year", ylab="Yks./pvm - Ind./day")
    lines(phen$day, phen$begin, col="blue")
    lines(phen$day, phen$end, col="red")
    text(as.Date(30,origin = "2000-01-01"),max(phen$med[apuphen])*0.95,alku,col="blue")
    text(as.Date(30,origin = "2000-01-01"),max(phen$med[apuphen])*0.83,keski,col="cyan")
    text(as.Date(23.5,origin = "2000-01-01"),max(phen$med[apuphen])*0.71,loppu,col="red")
    
  }
  
  dev.off()
  
  # Lajikohtaiset kannanmuutosprosentit
  trend$sp[l]=as.character(sp)
  trend$slopeLong[l]=round((N$end/N$begin-1)*100)
  trend$slopeShort[l]=round((N$end/N$med-1)*100)
  trend$Nbegin[l]=N$begin
  trend$Nmed[l]=N$med
  trend$Nend[l]=N$end
  trend$NbeginS[l]=sum(phen$begin[Halias_SP$SpB[l]:Halias_SP$SpE[l]],na.rm=TRUE)
  trend$NmedS[l]=sum(phen$med[Halias_SP$SpB[l]:Halias_SP$SpE[l]])
  trend$NendS[l]=sum(phen$end[Halias_SP$SpB[l]:Halias_SP$SpE[l]])
  trend$NbeginA[l]=sum(phen$begin[Halias_SP$AuB[l]:335],na.rm=TRUE)
  trend$NmedA[l]=sum(phen$med[Halias_SP$AuB[l]:335])
  trend$NendA[l]=sum(phen$end[Halias_SP$AuB[l]:335])
  
  
  ###### Lajikohtaiset pvm kohtaiset tiedot
  
  spphen=t(phen$paik)
  doy=as.Date(1:366, origin="1999-12-31")
  colnames(spphen)=as.character(doy)
  spphen=as.data.frame(spphen)
  spphen$type="paik"
  spphen[2,1:366]=t(phen$muutto)
  spphen$type[2]="muutto"
  spphen[3,1:366]=t(phen$begin)
  spphen$type[3]="begin"
  spphen[4,1:366]=t(phen$med)
  spphen$type[4]="med"
  spphen[5,1:366]=t(phen$end)
  spphen$type[5]="end"
  spphen$sp=Halias_SP$Species_Abb[l]
  tphen=rbind(tphen,spphen)
  
  ####
#spring$mig=NA
#spring$migDate=NA
#spring$loc=NA
#spring$locDate=NA
  
  
}
write.csv(tphen,"Halias_phenology20220119.csv")

PhenSprAut=unique(c(as.character(autumn$sp),as.character(spring$sp)))
PhenSprAut=as.data.frame(PhenSprAut)
colnames(PhenSprAut)=c("species")
PhenSprAut$S1980s=NA
PhenSprAut$S2000s=NA
PhenSprAut$S2010s=NA
PhenSprAut$A1980s=NA
PhenSprAut$A2000s=NA
PhenSprAut$A2010s=NA
PhenSprAut$S1980s5=NA
PhenSprAut$S2000s5=NA
PhenSprAut$S2010s5=NA
PhenSprAut$A1980s5=NA
PhenSprAut$A2000s5=NA
PhenSprAut$A2010s5=NA
PhenSprAut$S1980s95=NA
PhenSprAut$S2000s95=NA
PhenSprAut$S2010s95=NA
PhenSprAut$A1980s95=NA
PhenSprAut$A2000s95=NA
PhenSprAut$A2010s95=NA


for(i in 1:nrow(PhenSprAut)){
    
  if(length(which(spring$sp==as.character(PhenSprAut$species[i])))>0){
    PhenSprAut$S1980s[i]=unique(spring$begin[which(spring$sp==as.character(PhenSprAut$species[i]))])
    PhenSprAut$S2000s[i]=unique(spring$med[which(spring$sp==as.character(PhenSprAut$species[i]))])
    PhenSprAut$S2010s[i]=unique(spring$end[which(spring$sp==as.character(PhenSprAut$species[i]))])
    PhenSprAut$S1980s5[i]=unique(spring$begin5[which(spring$sp==as.character(PhenSprAut$species[i]))])
    PhenSprAut$S2000s5[i]=unique(spring$med5[which(spring$sp==as.character(PhenSprAut$species[i]))])
    PhenSprAut$S2010s5[i]=unique(spring$end5[which(spring$sp==as.character(PhenSprAut$species[i]))])
    PhenSprAut$S1980s95[i]=unique(spring$begin95[which(spring$sp==as.character(PhenSprAut$species[i]))])
    PhenSprAut$S2000s95[i]=unique(spring$med95[which(spring$sp==as.character(PhenSprAut$species[i]))])
    PhenSprAut$S2010s95[i]=unique(spring$end95[which(spring$sp==as.character(PhenSprAut$species[i]))])
  }
  if(length(which(autumn$sp==PhenSprAut$species[i]))>0){
    PhenSprAut$A1980s[i]=unique(autumn$begin[which(autumn$sp==as.character(PhenSprAut$species[i]))])
    PhenSprAut$A2000s[i]=unique(autumn$med[which(autumn$sp==as.character(PhenSprAut$species[i]))])
    PhenSprAut$A2010s[i]=unique(autumn$end[which(autumn$sp==as.character(PhenSprAut$species[i]))])
    PhenSprAut$A1980s5[i]=unique(autumn$begin5[which(autumn$sp==as.character(PhenSprAut$species[i]))])
    PhenSprAut$A2000s5[i]=unique(autumn$med5[which(autumn$sp==as.character(PhenSprAut$species[i]))])
    PhenSprAut$A2010s5[i]=unique(autumn$end5[which(autumn$sp==as.character(PhenSprAut$species[i]))])
    PhenSprAut$A1980s95[i]=unique(autumn$begin95[which(autumn$sp==as.character(PhenSprAut$species[i]))])
    PhenSprAut$A2000s95[i]=unique(autumn$med95[which(autumn$sp==as.character(PhenSprAut$species[i]))])
    PhenSprAut$A2010s95[i]=unique(autumn$end95[which(autumn$sp==as.character(PhenSprAut$species[i]))])
  }
}

write.csv(PhenSprAut, "MedianPhenology_Spring_Autumn_20220210.csv", row.names = FALSE)


# Combines trend information and phenology times & searches day records of locals and migrants

trend=as.data.frame(trend)
trend$sphenbegin=NA
trend$sphenmed=NA
trend$sphenend=NA
trend$aphenbegin=NA
trend$aphenmed=NA
trend$aphenend=NA
trend$Ntotal=NA

Record=matrix(nrow=0,ncol=5)
colnames(Record)=c("sp","Date","Sum","Type","Season")
Record=as.data.frame(Record)


for(i in 1:nrow(trend)){

  if(length(which(spring$sp==as.character(trend$sp[i])))>0){
  trend$sphenbegin[i]=unique(spring$begin[which(spring$sp==as.character(trend$sp[i]))])
  trend$sphenmed[i]=unique(spring$med[which(spring$sp==as.character(trend$sp[i]))])
  trend$sphenend[i]=unique(spring$end[which(spring$sp==as.character(trend$sp[i]))])
  }
  if(length(which(autumn$sp==as.character(trend$sp[i])))>0){
  trend$aphenbegin[i]=unique(autumn$begin[which(autumn$sp==as.character(trend$sp[i]))])
  trend$aphenmed[i]=unique(autumn$med[which(autumn$sp==as.character(trend$sp[i]))])
  trend$aphenend[i]=unique(autumn$end[which(autumn$sp==as.character(trend$sp[i]))])
  }
  trend$Ntotal[i]=sum(Halias$P[which(Halias$Species_Abb==as.character(trend$sp[i]))])+sum(Halias$M[which(Halias$Species_Abb==as.character(trend$sp[i]))])
  
  maxLsp=max(Halias$Local[which(Halias$Species_Abb==as.character(trend$sp[i]) & 
        Halias$Day.of.Year<Halias_SP$SpE[which(Halias_SP$Species_Abb==as.character(trend$sp[i]))] )]) 
  maxLau=max(Halias$Local[which(Halias$Species_Abb==as.character(trend$sp[i]) & 
                                  Halias$Day.of.Year>Halias_SP$AuB[which(Halias_SP$Species_Abb==as.character(trend$sp[i]))] )])
  maxMsp=max(Halias$Migr[which(Halias$Species_Abb==as.character(trend$sp[i]) & 
                                  Halias$Day.of.Year<Halias_SP$SpE[which(Halias_SP$Species_Abb==as.character(trend$sp[i]))] )])
  maxMau=max(Halias$Migr[which(Halias$Species_Abb==as.character(trend$sp[i]) & 
                                  Halias$Day.of.Year>Halias_SP$AuB[which(Halias_SP$Species_Abb==as.character(trend$sp[i]))] )])
  
  if(maxLsp>1){
    slrecord=matrix(nrow=length(as.character(Halias$Date[which(Halias$Species_Abb==as.character(trend$sp[i]) & 
        Halias$Local==maxLsp & Halias$Day.of.Year<Halias_SP$SpE[which(Halias_SP$Species_Abb==as.character(trend$sp[i]))] )])),ncol=5)
    colnames(slrecord)=c("sp","Date","Sum","Type","Season")
    slrecord=as.data.frame(slrecord)
    slrecord$sp=as.character(trend$sp[i])
    slrecord$Date=as.character(Halias$Date[which(Halias$Species_Abb==as.character(trend$sp[i]) & 
          Halias$Local==maxLsp & Halias$Day.of.Year<Halias_SP$SpE[which(Halias_SP$Species_Abb==as.character(trend$sp[i]))] )])
    slrecord$Sum=maxLsp
    slrecord$Type="Local"
    slrecord$Season="Spring"
    Record=rbind(Record,slrecord)
    }
    
    if(maxLau>1){
      alrecord=matrix(nrow=length(as.character(Halias$Date[which(Halias$Species_Abb==as.character(trend$sp[i]) & 
              Halias$Local==maxLau & Halias$Day.of.Year>Halias_SP$AuB[which(Halias_SP$Species_Abb==as.character(trend$sp[i]))])])),ncol=5)
      colnames(alrecord)=c("sp","Date","Sum","Type","Season")
      alrecord=as.data.frame(alrecord)
      alrecord$sp=as.character(trend$sp[i])
      alrecord$Date=as.character(Halias$Date[which(Halias$Species_Abb==as.character(trend$sp[i]) & 
              Halias$Local==maxLau & Halias$Day.of.Year>Halias_SP$AuB[which(Halias_SP$Species_Abb==as.character(trend$sp[i]))])])
      alrecord$Sum=maxLau
      alrecord$Type="Local"
      alrecord$Season="Autumn"
      Record=rbind(Record,alrecord)
      }
    
  if(maxMsp>1){
    smrecord=matrix(nrow=length(as.character(Halias$Date[which(Halias$Species_Abb==as.character(trend$sp[i]) & 
                                                                 Halias$Migr==maxMsp & Halias$Day.of.Year<Halias_SP$SpE[which(Halias_SP$Species_Abb==as.character(trend$sp[i]))] )])),ncol=5)
    colnames(smrecord)=c("sp","Date","Sum","Type","Season")
    smrecord=as.data.frame(smrecord)
    smrecord$sp=as.character(trend$sp[i])
    smrecord$Date=as.character(Halias$Date[which(Halias$Species_Abb==as.character(trend$sp[i]) & 
                                                   Halias$Migr==maxMsp & Halias$Day.of.Year<Halias_SP$SpE[which(Halias_SP$Species_Abb==as.character(trend$sp[i]))] )])
    smrecord$Sum=maxMsp
    smrecord$Type="Migr"
    smrecord$Season="Spring"
    Record=rbind(Record,smrecord)
  }
  
  if(maxMau>1){
    amrecord=matrix(nrow=length(as.character(Halias$Date[which(Halias$Species_Abb==as.character(trend$sp[i]) & 
                                                                 Halias$Migr==maxMau & Halias$Day.of.Year>Halias_SP$AuB[which(Halias_SP$Species_Abb==as.character(trend$sp[i]))])])),ncol=5)
    colnames(amrecord)=c("sp","Date","Sum","Type","Season")
    amrecord=as.data.frame(amrecord)
    amrecord$sp=as.character(trend$sp[i])
    amrecord$Date=as.character(Halias$Date[which(Halias$Species_Abb==as.character(trend$sp[i]) & 
                                                   Halias$Migr==maxMau & Halias$Day.of.Year>Halias_SP$AuB[which(Halias_SP$Species_Abb==as.character(trend$sp[i]))])])
    amrecord$Sum=maxMau
    amrecord$Type="Migr"
    amrecord$Season="Autumn"
    Record=rbind(Record,amrecord)
  }
  }

trend1=trend[which(trend$Nbegin>=1 & trend$Nmed>=1 & trend$Nend>=1),]

write.csv(trend1,"Halias1_trend20200415.csv")
write.csv(Record,"Halias_record20200415.csv")

#plot(log(trend$NendA[which(trend$NbeginS>1 & trend$NbeginA>1)]/trend$NmedA[which(trend$NbeginS>1 & trend$NbeginA>1)]),
#     log(trend$Nend[which(trend$NbeginS>1 & trend$NbeginA>1)]/trend$Nmed[which(trend$NbeginS>1 & trend$NbeginA>1)]))

############# Kuvaajien piirtäminen loppuu ##############



